Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.om
Class SingletonIterator

    java.lang.Object
      net.sf.saxon.om.SingletonIterator

All Implemented Interfaces:
  AtomizableIterator, AxisIterator, GroundedIterator, LastPositionFinder, LookaheadIterator, ReversibleIterator, SequenceIterator

public class SingletonIterator
extends java.lang.Object
implements AxisIterator, ReversibleIterator, LastPositionFinder, GroundedIterator, LookaheadIterator, AtomizableIterator

SingletonIterator: an iterator over a sequence of zero or one values

Field Summary

Fields inherited from interface net.sf.saxon.om.SequenceIterator
`ATOMIZABLE, GROUNDED, LAST_POSITION_FINDER, LOOKAHEAD`

Method Summary
`Item` | `current()` Get the current item in the sequence.
`SequenceIterator` | `getAnother()` Get another iterator over the same sequence of items, positioned at the start of the sequence.
`int` | `getLastPosition()` Get the last position (that is, the number of items in the sequence).
`int` | `getProperties()` Get properties of this iterator, as a bit-significant integer.
`SequenceIterator` | `getReverseIterator()` Get a new SequenceIterator that returns the same items in reverse order.
`Item` | `getValue()`
`boolean` | `hasNext()` Determine whether there are more items to come.
`static AxisIterator` | `makeIterator(Item item)` Factory method.
`Value` | `materialize()` Return a SequenceExtent containing all the items in the sequence returned by this SequenceIterator
`Item` | `next()` Get the next item in the sequence.
`int` | `position()` Return the current position in the sequence.
`void` | `setIsAtomizing(boolean atomizing)` Indicate that any nodes returned in the sequence will be atomized.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### makeIterator

    public static AxisIterator makeIterator(Item item)

  Factory method.

  Parameters:
    `item` - the item to iterate over
  Returns:
    a SingletonIterator over the supplied item, or an EmptyIterator if the supplied item is null.

### hasNext

    public boolean hasNext()

  Determine whether there are more items to come. Note that this operation is stateless and it is not necessary (or usual) to call it before calling next(). It is used only when there is an explicit need to tell if we are at the last element.

  Specified by:
    `hasNext` in interface `LookaheadIterator`
  Returns:
    true if there are more items

### next

    public Item next()

  Description copied from interface: `AxisIterator`
  Get the next item in the sequence.

  Specified by:
    `next` in interface `AxisIterator`
  Returns:
    the next Item. If there are no more nodes, return null.

### current

    public Item current()

  Description copied from interface: `AxisIterator`
  Get the current item in the sequence.

  Specified by:
    `current` in interface `AxisIterator`
  Returns:
    the current item, that is, the item most recently returned by next()

### position

    public int position()

  Return the current position in the sequence.

  Specified by:
    `position` in interface `AxisIterator`
  Returns:
    0 before the first call on next(); 1 before the second call on next(); -1 after the second call on next().

### getLastPosition

    public int getLastPosition()

  Description copied from interface: `LastPositionFinder`
  Get the last position (that is, the number of items in the sequence). This method is non-destructive: it does not change the state of the iterator. The result is undefined if the next() method of the iterator has already returned null. This method must not be called unless the result of getProperties() on the iterator includes the bit setting `SequenceIterator.LAST_POSITION_FINDER`

  Specified by:
    `getLastPosition` in interface `LastPositionFinder`

### getAnother

    public SequenceIterator getAnother()

  Description copied from interface: `AxisIterator`
  Get another iterator over the same sequence of items, positioned at the start of the sequence. It must be possible to call this method at any time, whether none, some, or all of the items in the original iterator have been read. The method is non-destructive: it does not change the state of the original iterator.

  Specified by:
    `getAnother` in interface `AxisIterator`
  Returns:
    a new iterator over the same sequence

### getReverseIterator

    public SequenceIterator getReverseIterator()

  Description copied from interface: `ReversibleIterator`
  Get a new SequenceIterator that returns the same items in reverse order. If this SequenceIterator is an AxisIterator, then the returned SequenceIterator must also be an AxisIterator.

  Specified by:
    `getReverseIterator` in interface `ReversibleIterator`

### getValue

    public Item getValue()

### materialize

    public Value materialize()

  Return a SequenceExtent containing all the items in the sequence returned by this SequenceIterator

  Specified by:
    `materialize` in interface `GroundedIterator`
  Returns:
    the corresponding SequenceExtent if it exists, or null if it doesn't; in this case the caller must construct a new SequenceExtent by calling new SequenceExtent(iter.getAnother())

### setIsAtomizing

    public void setIsAtomizing(boolean atomizing)

  Indicate that any nodes returned in the sequence will be atomized. This means that if it wishes to do so, the implementation can return the typed values of the nodes rather than the nodes themselves. The implementation is free to ignore this hint.

  This implementation attempts atomization of a singleton node if it is untyped. This avoids adding an iterator to iterate over the value in the common case where the typed value of the node is a single atomic value.

  Specified by:
    `setIsAtomizing` in interface `AtomizableIterator`
  Parameters:
    `atomizing` - true if the caller of this iterator will atomize any nodes that are returned, and is therefore willing to accept the typed value of the nodes instead of the nodes themselves.

### getProperties

    public int getProperties()

  Get properties of this iterator, as a bit-significant integer.

  Specified by:
    `getProperties` in interface `SequenceIterator`
  Returns:
    the properties of this iterator. This will be some combination of properties such as `GROUNDED`, `LAST_POSITION_FINDER`, and `LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD